/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   lem_in.h                                           :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: tmaze <tmaze@student.42.fr>                +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2019/03/23 17:31:19 by tmaze             #+#    #+#             */
/*   Updated: 2019/03/31 17:58:52 by tmaze            ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#ifndef LEM_IN_H
# define LEM_IN_H

# include "libft.h"

typedef struct		s_node
{
	char			*name;
	int				x;
	int				y;
	char			role;
	int				ind;
}					t_node;

typedef struct		s_ind
{
	int				index;
	int				weight;
	struct s_ind	*next;
}					t_ind;

typedef	struct		s_lmdata
{
	int				nbants;
	int				nb_nodes;
	t_list			*nodes;
	t_ind			**adj;
}					t_lmdata;

typedef struct		s_bfs
{
	int				parent;
	char			visited;
	int				queue;
}					t_bfs;

void				lm_initdata(t_lmdata *data);
int					lm_getparams(t_lmdata *data);

t_ind				*lst_indadd(t_ind **lst, int ind);
void				lst_inddel(t_ind **lst);

void				bfs(t_lmdata *data, t_bfs *tab, int start_ind, int end_ind);
t_ind				**edmunds_karp(t_lmdata *data, int start_ind, int end_ind);

#endif
